const fs = require('fs')
let moment = require('moment-timezone')
let _ = require('lodash')
const uuid = require('uniqid')
let pairs = ''

let res2
let res3
let res4
init()


async function init() {


    // res = await fs.readFileSync('run.csv', 'utf8');
    // res = res.split('\n')
    res2 = await fs.readFileSync('Run2.csv', 'utf8');
    res2 = res2.split('\n')

    res3 = await fs.readFileSync('Run3.csv', 'utf8');
    res3 = res3.split('\n')

    res4 = await fs.readFileSync('Run4.csv', 'utf8');
    res4 = res4.split('\n')
    let arr = []
    //  console.log(found('ETH', 'Lp2'))

    let com = await fs.readFileSync('com.json', 'utf8');
    com = JSON.parse(com)
    for (let i = 0; i < com.length; i++) {
        com[i].platform = com[i].platform.toLowerCase()
        let t = com[i].platform
        t = t.split('_')



        let pair = t[3].replace('usdt', '').replace('usd', '')
        let lp = t[4].replace('lp', 'Lp')
        com[i].lp = lp
        let p = t[t.length - 1].split('.')
        p = p[0].split(pair)[0]

        let uniq = pair + lp + p + capital(com[i].type.split(' ')[5]) + parseFloat(com[i].type.split(' ')[6]) * -10

        com[i].uniq = uniq + '_' + com[i].avgRunup + '_' + com[i].avgDrawdown + '_' + com[i].type.split(' ')[5] + '_' + (parseFloat(com[i].type.split(' ')[6]) * -1)


    }
    com = _.uniqBy(com, 'lp');
    let newCom = []
    for (let i = 0; i < com.length; i++) {
        newCom.push(com[i])
    }
    com = newCom
    createComResfileADV(JSON.stringify(com, null, 2))


    for (let i = 0; i < com.length; i++) {
        let t = com[i].platform
        t = t.split('_')
        let indicator = parseInt(t[t.length - 1])

        let pair = t[3].replace('usdt', '').replace('usd', '')
        pairs = pair
        let p = t[t.length - 1].split('.')
        p = p[0].split(pairs)[0]
        let lp = t[4].replace('lp', 'Lp')
        let f = found(indicator,pair, lp)
        f.period = p
        f.uniq = com[i].uniq
        console.log(com[i].platform, f.timeframe)
        arr.push(f)
    }
    arr = _.uniqBy(arr, 'name');


    // let header='RowNum,PPST1_stMnBarAge,PPST1_PvtPtPeriod,PPST1_AtrFactor,PPST1_AtrPeriod,szOmIdName\n'
    // for (let i=0;i<arr.length;i++)
    // {
    //     let qty=(i+5)*0.001
    //     let inline=(i+1)+','+arr[i].timeframe+','+arr[i].pvt+','+arr[i].factor+','+arr[i].period+','+arr[i].uniq+'_'+qty
    //     header=header+inline
    //     if (i !== arr.length-1)
    //         header= header+'\n'
    //
    // }

    // createRunResfileADV(header)


}

function isUpper(str) {
    return !/[a-z]/.test(str) && /[A-Z]/.test(str);
}

function capital(t) {
    let f = ''
    for (let j = 0; j < t.length; j++)
        if (isUpper(t[j]))
            f = f + t[j]

    return f
}

function createRunResfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile(pairs + '_TOP.csv', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function createComResfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile(pairs + 'newCom.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function found(indicator,pair, lp) {
    console.log(indicator,lp)
    let res=[]
    if (res.length ===0)
        return {timeframe: 0}
    if (indicator ===2)
        res=res2
    else if (indicator ===3)
        res=res3
    else if (indicator ===4)
        res =res4

    if (res.length ===0)
        return {timeframe: 0}
    for (let i = 0; i < res.length; i++) {
        if (!res[i].includes(lp + '_'))
            continue


        let d = res[i].split(',')
        let timeframe = d[13]
        // timeframe=timeframe.split(' ')
        // let newTimeframe='0d '
        // for (let z=1;z<timeframe.length;z++)
        // {
        //     newTimeframe=newTimeframe+timeframe[z]
        //     if (z !== timeframe.length-1)
        //         newTimeframe=newTimeframe+' '
        // }
        // timeframe=newTimeframe
        // let nStochPeriod=parseFloat(d[15])
        // let nStochSmoothingPeriod=parseFloat(d[16])
        // let dOttPercent=parseFloat(d[18])
        //
        // let name = d[92]

        // return {name, timeframe, nStochPeriod, nStochSmoothingPeriod, dOttPercent}
        return {timeframe}

    }
}


